<?php
/* 
Plugin Name: EMI Calculator
Plugin URI: https://codecanyon.net/user/tawhidurrahmandear/portfolio/ 
Description: This PlugIn will automatically match your theme's color. Go to Appearance > Widgets, and drag 'PlugIn' in sidebar or footer or into any widgetized area. Insert into page or post by PageBuilder. No need to use any short-code or to edit settings.
Version: 9.0
Author: Tawhidur Rahman Dear
Author URI: http://www.devilhunter.net/
License: Commercial

Developer: 
Tawhidur Rahman Dear
tawhidurrahmandear@gmail.com
Blog: http://tawhidurrahmandear.blogspot.com/
Facebook: http://www.facebook.com/tawhidurrahmandear/ 
Google Plus: http://plus.google.com/+tawhidurrahmandear/
YouTube: http://www.youtube.com/tawhidurrahmandear
LinkedIn: http://www.linkedin.com/in/tawhidurrahmandear

 */
 
 
 // Prevent direct file access
if ( ! defined ( 'ABSPATH' ) ) {
	exit;
}
// 
class tawhidurrahmandeartwentyone extends WP_Widget {


    protected $widget_slug = 'tawhidurrahmandeartwentyone';

	/*--------------------------------------------------*/
	/* Constructor
	/*--------------------------------------------------*/

	/**
	 * Specifies the classname and description, instantiates the widget,
	 * loads localization files, and includes necessary stylesheets and JavaScript.
	 */
	public function __construct() {

		// load plugin text domain
		add_action( 'init', array( $this, 'tawhidurrahmandeartwentyone' ) );

		// Hooks fired when the Widget is activated and deactivated
		register_activation_hook( __FILE__, array( $this, 'activate' ) );
		register_deactivation_hook( __FILE__, array( $this, 'deactivate' ) );

		// description
		parent::__construct(
			$this->get_widget_slug(),
			__( 'EMI Calculator', $this->get_widget_slug() ),
			array(
				'classname'  => $this->get_widget_slug().'-class',
				'description' => __( 'Drag the PlugIn in sidebar or footer. Insert into page or post by PageBuilder', $this->get_widget_slug() )
			)
		);


		// Register site styles and scripts
		add_action( 'wp_enqueue_scripts', array( $this, 'register_widget_styles' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'register_widget_scripts' ) );

		// Refreshing the widget's cached output with each new post
		add_action( 'save_post',    array( $this, 'flush_widget_cache' ) );
		add_action( 'deleted_post', array( $this, 'flush_widget_cache' ) );
		add_action( 'switch_theme', array( $this, 'flush_widget_cache' ) );

	} // end constructor


    /**
     * Return the widget slug.
     */
    public function get_widget_slug() {
        return $this->widget_slug;
    }

	/*--------------------------------------------------*/
	/* Widget API Functions
	/*--------------------------------------------------*/


	public function widget( $args, $instance ) {

		
		// Check if there is a cached output
		$cache = wp_cache_get( $this->get_widget_slug(), 'widget' );

		if ( !is_array( $cache ) )
			$cache = array();

		if ( ! isset ( $args['widget_id'] ) )
			$args['widget_id'] = $this->id;

		if ( isset ( $cache[ $args['widget_id'] ] ) )
			return print $cache[ $args['widget_id'] ];
		
		$cur_arg = array(
			'title'	=> $instance['title']
		);
		extract( $cur_arg );


		extract( $args, EXTR_SKIP );

		$widget_string = $before_widget;

		// TODO: Here is where I manipulate my widget's values based on their input fields
		ob_start();
		include( plugin_dir_path( __FILE__ ) . 'files/widget.php' );
		$widget_string .= ob_get_clean();
		$widget_string .= $after_widget;


		$cache[ $args['widget_id'] ] = $widget_string;

		wp_cache_set( $this->get_widget_slug(), $cache, 'widget' );

		print $widget_string;

	} // end widget
	
	
	public function flush_widget_cache() 
	{
    	wp_cache_delete( $this->get_widget_slug(), 'widget' );
	}
	/**
	 * Processes the widget's options to be saved.
	 */
	public function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['title'] = strip_tags($new_instance['title']);

		return $instance;

	} // end widget

	/**
	 */
	public function form( $instance ) {

		$instance = wp_parse_args(
			(array) $instance
		);

		include( plugin_dir_path(__FILE__) . 'files/admin.php' );

	} // end form

	/*--------------------------------------------------*/
	/* Public Functions
	/*--------------------------------------------------*/

	/**
	 * Loads the Widget's text domain for localization and translation.
	 */
	public function tawhidurrahmandeartwentyone() {

		load_plugin_textdomain( $this->get_widget_slug(), false, plugin_dir_path( __FILE__ ) . 'lang/' );

	} // end localixation

	/**
	 * Fired when the plugin is activated.
	 *
	 * @param  boolean $network_wide True if WPMU superadmin uses "Network Activate" action, false if WPMU is disabled or plugin is activated on an individual blog.
	 */
	public function activate( $network_wide ) {
		// TODO define activation functionality here
	} // end activate

	/**
	 * Fired when the plugin is deactivated.
	 *
	 * @param boolean $network_wide True if WPMU superadmin uses "Network Activate" action, false if WPMU is disabled or plugin is activated on an individual blog
	 */
	public function deactivate( $network_wide ) {
		// TODO define deactivation functionality here
	} // end deactivate



	/**
	 * Registers and enqueues widget-specific styles.
	 */
	public function register_widget_styles() {

		wp_enqueue_style( $this->get_widget_slug().'-widget-styles', plugins_url( 'css/widget.css', __FILE__ ) );

	} // end register_widget_styles

	/**
	 * Registers and enqueues widget-specific scripts.
	 */
	 
	 
	public function register_widget_scripts() {
		
		// Keep the next line if you want to use WordPress Core jQuery, otherwise delete
		// Keep the next line if you want to use your own extra JavaScript. Just change URL. Otherwise delete

	
		wp_enqueue_script( $this->get_widget_slug().'-script3', plugins_url( 'js/widget.js', __FILE__ ), array('jquery') );

	} // end register_widget_scripts

} // end class


add_action( 'widgets_init', create_function( '', 'register_widget("tawhidurrahmandeartwentyone");' ) );
